Index: trunk/VUT/work/ogre_changes/OgreMain/src/OgreRenderQueueSortingGrouping.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/OgreMain/src/OgreRenderQueueSortingGrouping.cpp	(revision 115)
+++ trunk/VUT/work/ogre_changes/OgreMain/src/OgreRenderQueueSortingGrouping.cpp	(revision 115)
@@ -0,0 +1,319 @@
+/*
+-----------------------------------------------------------------------------
+This source file is part of OGRE
+(Object-oriented Graphics Rendering Engine)
+For the latest info, see http://www.ogre3d.org/
+
+Copyright (c) 2000-2005 The OGRE Team
+Also see acknowledgements in Readme.html
+
+This program is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the Free Software
+Foundation; either version 2 of the License, or (at your option) any later
+version.
+
+This program is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public License along with
+this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+Place - Suite 330, Boston, MA 02111-1307, USA, or go to
+http://www.gnu.org/copyleft/lesser.txt.
+-----------------------------------------------------------------------------
+*/
+#include "OgreStableHeaders.h"
+#include "OgreRenderQueueSortingGrouping.h"
+
+namespace Ogre {
+
+    //-----------------------------------------------------------------------
+    void RenderPriorityGroup::destroySolidPassMap(SolidRenderablePassMap& passmap)
+    {
+        // destroy all the pass map entries
+        SolidRenderablePassMap::iterator i, iend;
+        iend = passmap.end();
+        for (i = passmap.begin(); i != iend; ++i)
+        {
+            // Free the list associated with this pass
+            delete i->second;
+        }
+        passmap.clear();
+    }
+    //-----------------------------------------------------------------------
+    void RenderPriorityGroup::removeSolidPassEntry(Pass* p)
+    {
+        SolidRenderablePassMap::iterator i;
+
+        i = mSolidPasses.find(p);
+        if (i != mSolidPasses.end())
+        {
+            // free memory
+            delete i->second;
+            // erase from map
+            mSolidPasses.erase(i);
+        }
+
+        i = mSolidPassesDiffuseSpecular.find(p);
+        if (i != mSolidPassesDiffuseSpecular.end())
+        {
+            // free memory
+            delete i->second;
+            // erase from map
+            mSolidPassesDiffuseSpecular.erase(i);
+        }
+        i = mSolidPassesDecal.find(p);
+        if (i != mSolidPassesDecal.end())
+        {
+            // free memory
+            delete i->second;
+            // erase from map
+            mSolidPassesDecal.erase(i);
+        }
+        i = mSolidPassesNoShadow.find(p);
+        if (i != mSolidPassesNoShadow.end())
+        {
+            // free memory
+            delete i->second;
+            // erase from map
+            mSolidPassesNoShadow.erase(i);
+        }
+
+    }
+    //-----------------------------------------------------------------------
+    void RenderPriorityGroup::clearSolidPassMap(SolidRenderablePassMap& passmap)
+    {
+        SolidRenderablePassMap::iterator i, iend;
+        iend = passmap.end();
+        for (i = passmap.begin(); i != iend; ++i)
+        {
+            // Clear the list associated with this pass, but leave the pass entry
+            i->second->clear();
+        }
+    }
+    //-----------------------------------------------------------------------
+    void RenderPriorityGroup::addRenderable(Renderable* rend)
+    {
+        // Check material & technique supplied (the former since the default implementation
+        // of getTechnique is based on it for backwards compatibility
+        Technique* pTech;
+        if(rend->getMaterial().isNull() || !rend->getTechnique())
+        {
+            // Use default base white
+			MaterialPtr baseWhite = MaterialManager::getSingleton().getByName("BaseWhite");
+            pTech = baseWhite->getTechnique(0);
+        }
+        else
+        {
+            // Get technique
+            pTech = rend->getTechnique();
+        }
+
+        // Transparent and depth settings mean depth sorting is required?
+        if (pTech->isTransparent() && 
+            !(pTech->isDepthWriteEnabled() && pTech->isDepthCheckEnabled()) )
+        {
+            addTransparentRenderable(pTech, rend);
+        }
+        else
+        {
+            if (mSplitNoShadowPasses && !pTech->getParent()->getReceiveShadows())
+            {
+                // Add solid renderable and add passes to no-shadow group
+                addSolidRenderable(pTech, rend, true);
+            }
+            else
+            {
+                if (mSplitPassesByLightingType)
+                {
+                    addSolidRenderableSplitByLightType(pTech, rend);
+                }
+                else
+                {
+                    addSolidRenderable(pTech, rend, false);
+                }
+            }
+        }
+
+    }
+    //-----------------------------------------------------------------------
+    void RenderPriorityGroup::addSolidRenderable(Technique* pTech, 
+        Renderable* rend, bool addToNoShadow)
+    {
+        Technique::PassIterator pi = pTech->getPassIterator();
+
+        SolidRenderablePassMap* passMap;
+        if (addToNoShadow)
+        {
+            passMap = &mSolidPassesNoShadow;
+        }
+        else
+        {
+            passMap = &mSolidPasses;
+        }
+
+
+        while (pi.hasMoreElements())
+        {
+            // Insert into solid list
+            Pass* p = pi.getNext();
+            SolidRenderablePassMap::iterator i = passMap->find(p);
+            if (i == passMap->end())
+            {
+                std::pair<SolidRenderablePassMap::iterator, bool> retPair;
+                // Create new pass entry, build a new list
+                // Note that this pass and list are never destroyed until the engine
+                // shuts down, although the lists will be cleared
+                retPair = passMap->insert(
+                    SolidRenderablePassMap::value_type(p, new RenderableList() ) );
+                assert(retPair.second && "Error inserting new pass entry into SolidRenderablePassMap");
+                i = retPair.first;
+            }
+            // Insert renderable
+            i->second->push_back(rend);
+
+        }
+    }
+    //-----------------------------------------------------------------------
+    void RenderPriorityGroup::addSolidRenderableSplitByLightType(Technique* pTech, Renderable* rend)
+    {
+        // Divide the passes into the 3 categories
+        Technique::IlluminationPassIterator pi = 
+            pTech->getIlluminationPassIterator();
+
+        while (pi.hasMoreElements())
+        {
+            // Insert into solid list
+            IlluminationPass* p = pi.getNext();
+            SolidRenderablePassMap* passMap;
+            switch(p->stage)
+            {
+            case IS_AMBIENT:
+                passMap = &mSolidPasses;
+                break;
+            case IS_PER_LIGHT:
+                passMap = &mSolidPassesDiffuseSpecular;
+                break;
+            case IS_DECAL:
+                passMap = &mSolidPassesDecal;
+                break;
+            };
+
+            SolidRenderablePassMap::iterator i = passMap->find(p->pass);
+            if (i == passMap->end())
+            {
+                std::pair<SolidRenderablePassMap::iterator, bool> retPair;
+                // Create new pass entry, build a new list
+                // Note that this pass and list are never destroyed until the engine
+                // shuts down, although the lists will be cleared
+                retPair = passMap->insert(
+                    SolidRenderablePassMap::value_type(p->pass, new RenderableList() ) );
+                assert(retPair.second && "Error inserting new pass entry into SolidRenderablePassMap");
+                i = retPair.first;
+            }
+            // Insert renderable
+            i->second->push_back(rend);
+        }
+    }
+    //-----------------------------------------------------------------------
+    void RenderPriorityGroup::addTransparentRenderable(Technique* pTech, Renderable* rend)
+    {
+        Technique::PassIterator pi = pTech->getPassIterator();
+
+        while (pi.hasMoreElements())
+        {
+            // Insert into transparent list
+            mTransparentPasses.push_back(RenderablePass(rend, pi.getNext()));
+        }
+    }
+    //-----------------------------------------------------------------------
+    void RenderPriorityGroup::sort(const Camera* cam)
+    {
+        TransparentQueueItemLess transFunctor;
+        transFunctor.camera = cam;
+
+        std::stable_sort(mTransparentPasses.begin(), mTransparentPasses.end(), 
+            transFunctor);
+    }
+    //-----------------------------------------------------------------------
+    void RenderPriorityGroup::clear(void)
+    {
+        SolidRenderablePassMap::iterator i, iend;
+        // Delete queue groups which are using passes which are to be
+        // deleted, we won't need these any more and they clutter up 
+        // the list and can cause problems with future clones
+        const Pass::PassSet& graveyardList = Pass::getPassGraveyard();
+        Pass::PassSet::const_iterator gi, giend;
+        giend = graveyardList.end();
+        for (gi = graveyardList.begin(); gi != giend; ++gi)
+        {
+            removeSolidPassEntry(*gi);
+        }
+
+        // Now remove any dirty passes, these will have their hashes recalculated
+        // by the parent queue after all groups have been processed
+        // If we don't do this, the std::map will become inconsistent for new insterts
+        const Pass::PassSet& dirtyList = Pass::getDirtyHashList();
+        Pass::PassSet::const_iterator di, diend;
+        diend = dirtyList.end();
+        for (di = dirtyList.begin(); di != diend; ++di)
+        {
+            removeSolidPassEntry(*di);
+        }
+        // NB we do NOT clear the graveyard or the dirty list here, because 
+        // it needs to be acted on for all groups, the parent queue takes 
+        // care of this afterwards
+
+        // We do not clear the unchanged solid pass maps, only the contents of each list
+        // This is because we assume passes are reused a lot and it saves resorting
+        clearSolidPassMap(mSolidPasses);
+        clearSolidPassMap(mSolidPassesDecal);
+        clearSolidPassMap(mSolidPassesDiffuseSpecular);
+        clearSolidPassMap(mSolidPassesNoShadow);
+
+        // Always empty the transparents list
+        mTransparentPasses.clear();
+
+    }
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE	
+	//-----------------------------------------------------------------------
+    void RenderPriorityGroup::clearSolids(void)
+    {
+      /*  SolidRenderablePassMap::iterator i, iend;
+        // Delete queue groups which are using passes which are to be
+        // deleted, we won't need these any more and they clutter up 
+        // the list and can cause problems with future clones
+        const Pass::PassSet& graveyardList = Pass::getPassGraveyard();
+        Pass::PassSet::const_iterator gi, giend;
+        giend = graveyardList.end();
+        for (gi = graveyardList.begin(); gi != giend; ++gi)
+        {
+            removeSolidPassEntry(*gi);
+        }
+
+        // Now remove any dirty passes, these will have their hashes recalculated
+        // by the parent queue after all groups have been processed
+        // If we don't do this, the std::map will become inconsistent for new insterts
+        const Pass::PassSet& dirtyList = Pass::getDirtyHashList();
+        Pass::PassSet::const_iterator di, diend;
+        diend = dirtyList.end();
+        for (di = dirtyList.begin(); di != diend; ++di)
+        {
+            removeSolidPassEntry(*di);
+        }*/
+        // NB we do NOT clear the graveyard or the dirty list here, because 
+        // it needs to be acted on for all groups, the parent queue takes 
+        // care of this afterwards
+
+        // We do not clear the unchanged solid pass maps, only the contents of each list
+        // This is because we assume passes are reused a lot and it saves resorting
+        clearSolidPassMap(mSolidPasses);
+        clearSolidPassMap(mSolidPassesDecal);
+        clearSolidPassMap(mSolidPassesDiffuseSpecular);
+        clearSolidPassMap(mSolidPassesNoShadow);
+    }
+#endif // GTP_VISIBILITY_MODIFIED_OGRE		
+//-----------------------------------------------------------------------
+
+}
+
Index: trunk/VUT/work/ogre_changes/OgreMain/src/OgreSceneManager.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/OgreMain/src/OgreSceneManager.cpp	(revision 99)
+++ trunk/VUT/work/ogre_changes/OgreMain/src/OgreSceneManager.cpp	(revision 115)
@@ -59,5 +59,5 @@
 #include "OgreDataStream.h"
 #include "OgreStaticGeometry.h"
-#include <windows.h> //matt: remove later
+
 // This class implements the most basic scene manager
 
@@ -665,7 +665,4 @@
         if (lastUsedVertexProgram)
         {
-			//matt: remove later
-			//OutputDebugString("unbinding vertex program\n");
-
             mDestRenderSystem->unbindGpuProgram(GPT_VERTEX_PROGRAM);
             lastUsedVertexProgram = false;
@@ -990,5 +987,4 @@
                                const String& groupName)
 {
-    mSkyPlaneEnabled = enable;
     if (enable)
     {
@@ -1061,4 +1057,5 @@
 
     }
+	mSkyPlaneEnabled = enable;
 }
 //-----------------------------------------------------------------------
@@ -1071,5 +1068,4 @@
                              const String& groupName)
 {
-    mSkyBoxEnabled = enable;
     if (enable)
     {
@@ -1143,5 +1139,5 @@
 
     }
-
+	mSkyBoxEnabled = enable;
 }
 //-----------------------------------------------------------------------
@@ -1157,5 +1153,4 @@
                               const String& groupName)
 {
-    mSkyDomeEnabled = enable;
     if (enable)
     {
@@ -1164,5 +1159,5 @@
         {
             OGRE_EXCEPT(Exception::ERR_INVALIDPARAMS, 
-                "Sky dome material '" + materialName + " not found.",
+                "Sky dome material '" + materialName + "' not found.",
                 "SceneManager::setSkyDome");
         }
@@ -1208,4 +1203,5 @@
 
     }
+	mSkyDomeEnabled = enable;
 }
 //-----------------------------------------------------------------------
@@ -2658,4 +2654,6 @@
     {
         Light* l = i->second;
+		if (l->isVisible())
+		{
         if (l->getType() == Light::LT_DIRECTIONAL)
         {
@@ -2675,4 +2673,5 @@
 
         }
+    }
     }
 
@@ -4180,5 +4179,5 @@
 #ifdef GTP_VISIBILITY_MODIFIED_OGRE
 //-----------------------------------------------------------------------
-void SceneManager::_renderSceneNode( Camera *cam, SceneNode *node )
+void SceneManager::_renderSceneNode(Camera *cam, SceneNode *node, bool leaveTransparentsInQueue)
 {
 	node->_findVisibleObjects(cam, getRenderQueue(), false, mDisplayNodes, false);
@@ -4186,8 +4185,8 @@
 	
 	// delete all rendered objects from renderqueue
-	_deleteRenderedQueueGroups();
-}
-//-----------------------------------------------------------------------
-void SceneManager::_deleteRenderedQueueGroups()
+	_deleteRenderedQueueGroups(leaveTransparentsInQueue);
+}
+//-----------------------------------------------------------------------
+void SceneManager::_deleteRenderedQueueGroups(bool leaveTransparentsInQueue)
 {
 	RenderQueue::QueueGroupIterator queueIt = getRenderQueue()->_getQueueGroupIterator();
@@ -4200,5 +4199,14 @@
 
 		if (isRenderQueueToBeProcessed(qId))
+		{
+			if (leaveTransparentsInQueue)
+			{
+				pGroup->clearSolids();
+			}
+			else
+			{
 			pGroup->clear();
+	}
+		}
 	}
 	
Index: trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/include/OgreOctreeSceneManager.h
===================================================================
--- trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/include/OgreOctreeSceneManager.h	(revision 112)
+++ trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/include/OgreOctreeSceneManager.h	(revision 115)
@@ -105,10 +105,14 @@
 	/** Renders one octant of an octree, i.e., renders current octant
 		node and does not traverse deeper into the tree.
+
 		@remark Note that OctreeNode instances are NOT part of the octree 
 		hierarchy, instead one octant of an Octree contains many OctreeNode instances.
-		@param octree the octree to be rendered
+		
 		@param cam current camera
+		@param octree the octant to be rendered (without children)
+		@param onlyShadowCasters if only shadow casters are rendered
+		@param leaveTransparentsInQueue if transparemt should be left in queue for later processing
 	*/
-	void _renderOctant(Camera* cam, Octree *octree, bool onlyShadowCasters);
+	void _renderOctant(Camera* cam, Octree *octree, bool onlyShadowCasters, bool leaveTransparentsInQueue = false);
 
 	/** Returns stored list of boxes */
@@ -214,4 +218,5 @@
     IntersectionSceneQuery* createIntersectionQuery(unsigned long mask);
 
+
 protected:
 
Index: trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/src/OgreOctree.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/src/OgreOctree.cpp	(revision 61)
+++ trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/src/OgreOctree.cpp	(revision 115)
@@ -109,9 +109,4 @@
 		mDepth = 0;
 
-	//matt: remove later
-	//char msg[100];
-	//sprintf(msg, "creating new octant in depth %d", mDepth);
-	//OutputDebugString(msg);
-
 #endif //GTP_VISIBILITY_MODIFIED_OGRE
     mNumNodes = 0;
@@ -171,9 +166,4 @@
 
 	mWireBoundingBox->setupBoundingBox(mBox);
-
-	// matt: change this back
-	//AxisAlignedBox box; _getCullBounds(&box); 
-	//mWireBoundingBox->setupBoundingBox(box);
-
     return mWireBoundingBox;
 }
Index: trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/src/OgreOctreeSceneManager.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/src/OgreOctreeSceneManager.cpp	(revision 112)
+++ trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/src/OgreOctreeSceneManager.cpp	(revision 115)
@@ -39,5 +39,5 @@
 #include <OgreOctreeCamera.h>
 #include <OgreRenderSystem.h>
-#include <windows.h>
+
 
 extern "C"
@@ -508,8 +508,4 @@
         }
 
-		//matt: remove later
-		//OutputDebugString("adding octree node\n");
-		
-
         _addOctreeNode( n, octant -> mChildren[ x ][ y ][ z ], ++depth );
 
@@ -1173,5 +1169,6 @@
 }
 //-----------------------------------------------------------------------
-void OctreeSceneManager::_renderOctant(Camera *cam, Octree *octant, bool onlyShadowCasters)
+void OctreeSceneManager::_renderOctant(Camera *cam, Octree *octant, bool onlyShadowCasters, 
+									   bool leaveTransparentsInQueue)//, bool useZPassQueue)
 {
 	//Add stuff to be rendered;
@@ -1188,5 +1185,4 @@
 		{
 			sn->_addToRenderQueue(cam, getRenderQueue(), onlyShadowCasters);
-			//node->_findVisibleObjects(cam, getRenderQueue(), false, mDisplayNodes, false);
 			mVisible.push_back(sn);
 
@@ -1207,12 +1203,14 @@
 	if (mShowBoxes)
 	{
+		octant->getWireBoundingBox()->setMaterial("BaseWhiteNoLighting");
+
 		getRenderQueue()->addRenderable(octant->getWireBoundingBox());
 		mBoxes.push_back(octant->getWireBoundingBox());
 	}
 
+	//-- the actual rendering
 	SceneManager::_renderVisibleObjects();
-
 	// delete all rendered objects from the render queue
-	_deleteRenderedQueueGroups();
+	_deleteRenderedQueueGroups(leaveTransparentsInQueue);
 }
 #endif // GTP_VISIBILITY_MODIFIED_OGRE
Index: trunk/VUT/work/ogre_changes/Samples/Common/include/ExampleFrameListener.h
===================================================================
--- trunk/VUT/work/ogre_changes/Samples/Common/include/ExampleFrameListener.h	(revision 100)
+++ trunk/VUT/work/ogre_changes/Samples/Common/include/ExampleFrameListener.h	(revision 115)
@@ -300,9 +300,6 @@
 		return true;
 	}
-#ifdef GTP_VISIBILITY_MODIFIED_OGRE
-	virtual void moveCamera() // made virtual by matt (16.05.05)
-#else
+
 	void moveCamera()
-#endif // GTP_VISIBILTIY_MODIFIED_OGRE
 	{
 
Index: trunk/VUT/work/ogre_changes/RenderSystems/GL/include/OgreGLHardwareOcclusionQuery.h
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/GL/include/OgreGLHardwareOcclusionQuery.h	(revision 92)
+++ trunk/VUT/work/ogre_changes/RenderSystems/GL/include/OgreGLHardwareOcclusionQuery.h	(revision 115)
@@ -88,15 +88,6 @@
 	void beginOcclusionQuery();
 	void endOcclusionQuery();
-
-#ifdef GTP_VISIBILITY_MODIFIED_OGRE
-	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult,
-							 const HW_OCCLUSIONQUERY flag  ); 
-	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult );
-#else
-	bool pullOcclusionQuery( unsigned int* NumOfFragments );
 	bool pullOcclusionQuery( unsigned int* NumOfFragments, const HW_OCCLUSIONQUERY flag  ); 
-#endif // GTP_VISIBILITY_MODIFIED_OGRE
-
-	unsigned int getLastQuerysPixelcount() { return m_uintPixelCount; }
+	unsigned int getLastQuerysPixelcount() { return mPixelCount; }
 
 	// This functions are optional, it's a simple filter that simply skipps some hardware occlusion tests on visable objects only
@@ -115,8 +106,10 @@
 	  */
 
-	void setSkipRate( int skip ) { m_Skip = skip; }		// Using 2 only 50 % of the tests are actully made and 3 results in only 33% of the tests. So on.
-	int	 getSkipRate() { return m_Skip; } 
+	void setSkipRate( int skip ) { mSkipInterval = skip; }		// Using 2 only 50 % of the tests are actully made and 3 results in only 33% of the tests. So on.
+	int	 getSkipRate() { return mSkipInterval; } 
 
-
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE
+	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, const HW_OCCLUSIONQUERY flag = HWOCCLUSIONQUERY_FLUSH ); 
+#endif // GTP_VISIBILITY_MODIFIED_OGRE
 //----------------------------------------------------------------------
 // Protected members
@@ -124,12 +117,11 @@
 protected:
 
-	unsigned int	m_uintPixelCount;
-	unsigned int	m_uintQuery[1];
+	unsigned int	mPixelCount;
+	GLuint			mQueryID;
 	bool			m_bOcclusionQuery;
-	int				m_SkipCounter;		// m_SkipConter =  m_SkipConter % m_Skip; if ( m_SkipConter == 0 && m_uintPixelCount !=0 ) TestHWOcclusion else just return 
-	static int		m_Skip;				// This is shared by all instancies
-	bool			m_bHWOcclusionSupport;
+	int				mSkipCounter;
+	int				mSkipInterval;
+	bool			mHasOcclusionSupport;
 };
-
 
 }
Index: trunk/VUT/work/ogre_changes/RenderSystems/GL/include/OgreGLPrerequisites.h
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/GL/include/OgreGLPrerequisites.h	(revision 97)
+++ trunk/VUT/work/ogre_changes/RenderSystems/GL/include/OgreGLPrerequisites.h	(revision 115)
@@ -70,4 +70,8 @@
 extern GL_SecondaryColorPointerEXT_Func glSecondaryColorPointerEXT_ptr;
 
+// Pointer to glSecondaryColor3fEXT function
+typedef void (APIENTRY *GL_SecondaryColor3fEXT_Func)(GLfloat, GLfloat, GLfloat);
+extern GL_SecondaryColor3fEXT_Func glSecondaryColor3fEXT_ptr;
+
 // Pointer to glGenBuffersARB function
 typedef void (APIENTRY *GL_GenBuffersARB_Func)(GLsizei, GLuint*);
@@ -208,39 +212,4 @@
 extern GL_GetOcclusionQueryuivNV_Func glGetOcclusionQueryuivNV_ptr;
 
-#ifdef GTP_VISIBILITY_MODIFIED_OGRE
-// Pointer to glGenQueriesARB function
-typedef void (APIENTRY *GL_GenQueriesARB_Func) (GLsizei n, GLuint *ids);
-extern GL_GenQueriesARB_Func glGenQueriesARB_ptr;
-
-// Pointer to glDeleteQueriesARB function
-typedef void (APIENTRY *GL_DeleteQueriesARB_Func) (GLsizei n, const GLuint *ids);
-extern GL_DeleteQueriesARB_Func glDeleteQueriesARB_ptr;
-
-// Pointer to glIsQueryARB function
-typedef GLboolean (APIENTRY *GL_IsQueryARB_Func) (GLuint id);
-extern GL_IsQueryARB_Func glIsQueryARB_ptr;
-
-// Pointer to glBeginQueryARB function
-typedef void (APIENTRY *GL_BeginQueryARB_Func) (GLenum target, GLuint id);
-extern GL_BeginQueryARB_Func glBeginQueryARB_ptr;
-
-// Pointer to glEndQueryARB function
-typedef void (APIENTRY *GL_EndQueryARB_Func) (GLenum target);
-extern GL_EndQueryARB_Func glEndQueryARB_ptr;
-
-// Pointer to glGetQueryivARB function
-typedef void (APIENTRY *GL_GetQueryivARB_Func) (GLuint id, GLenum pname, GLint *params);
-extern GL_GetQueryivARB_Func glGetQueryivARB_ptr;
-
-// Pointer to glGetQueryObjectivARB function
-typedef void (APIENTRY *GL_GetQueryObjectivARB_Func) (GLuint id, GLenum pname, GLint *params);
-extern GL_GetQueryObjectivARB_Func glGetQueryObjectivARB_ptr;
-
-// Pointer to glGetQueryObjectuivARB function
-typedef void (APIENTRY *GL_GetQueryObjectuivARB_Func) (GLuint id, GLenum pname, GLuint *params);
-extern GL_GetQueryObjectuivARB_Func glGetQueryObjectuivARB_ptr;
-
-#endif // GTP_VISIBILITY_MODIFIED_OGRE
-
 extern PFNGLCOMPRESSEDTEXIMAGE1DARBPROC glCompressedTexImage1DARB_ptr;
 extern PFNGLCOMPRESSEDTEXIMAGE2DARBPROC glCompressedTexImage2DARB_ptr;
@@ -253,4 +222,31 @@
 };
 
+// Pointer to glGenQueriesARB function
+typedef void (APIENTRY *GL_GenQueriesARB_Func) (GLuint n, GLuint *ids);
+extern GL_GenQueriesARB_Func glGenQueriesARB_ptr;
+
+// Pointer to glDeleteQueriesARB function
+typedef void (APIENTRY *GL_DeleteQueriesARB_Func) (GLuint n, const GLuint *ids);
+extern GL_DeleteQueriesARB_Func glDeleteQueriesARB_ptr;
+
+// Pointer to glBeginQueryARB function
+typedef void (APIENTRY *GL_BeginQueryARB_Func) (GLenum target, GLuint id);
+extern GL_BeginQueryARB_Func glBeginQueryARB_ptr;
+
+// Pointer to glEndQueryARB function
+typedef void (APIENTRY *GL_EndQueryARB_Func) (GLenum target);
+extern GL_EndQueryARB_Func glEndQueryARB_ptr;
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE
+// Pointer to glGetQueryivARB function
+typedef void (APIENTRY *GL_GetQueryivARB_Func) (GLuint id, GLenum pname, GLint *params);
+extern GL_GetQueryivARB_Func glGetQueryivARB_ptr;
+
+// Pointer to glGetQueryObjectivARB function
+typedef void (APIENTRY *GL_GetQueryObjectivARB_Func) (GLuint id, GLenum pname, GLint *params);
+extern GL_GetQueryObjectivARB_Func glGetQueryObjectivARB_ptr;
+#endif // GTP_VISIBILITY_MODIFIED_OGRE
+// Pointer to glGetQueryObjectuivARB function
+typedef void (APIENTRY *GL_GetQueryObjectuivARB_Func) (GLuint id, GLenum pname, GLuint *params);
+extern GL_GetQueryObjectuivARB_Func glGetQueryObjectuivARB_ptr;
 
 
